=== debian/control ===
Source: ltrd
Section: electronics
Priority: optional
Maintainer: Borisov Alexey <borisov@lcard.ru>
Build-Depends: debhelper (>= 8.0.0), cmake, libxml2-dev, libdaemon-dev, libusb-1.0-0-dev
Standards-Version: 3.9.3
Homepage: http://www.lcard.ru
#Vcs-Git: git://git.debian.org/collab-maint/ltrd.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/ltrd.git;a=summary


Package: ltrd
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base (>= 3.0-6), adduser, udev
Suggests: libltrapi1 (>= 1.25)
#Recommends: upstart
Description:Daemon for control L Card LTR-Crates
 Ltrd controls LTR-Crates. ltrapi uses ltrd for make all 
 operatios with LTR-crates and LTR-modules.
