## ltrd 2.1.8.14

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.6)
+cmake_minimum_required(VERSION 2.8.12)
 
 
 if(NOT LTR_SDK_SUFFIX)
@@ -12,8 +12,8 @@
 
 set(LTRD_VERSION_MAJOR  2)
 set(LTRD_VERSION_MINOR  1)
-set(LTRD_VERSION_REV    5)
-set(LTRD_VERSION_PATCH  0)
+set(LTRD_VERSION_REV    8)
+set(LTRD_VERSION_PATCH  14)
 set(LTRD_VERSION ${LTRD_VERSION_MAJOR}.${LTRD_VERSION_MINOR}.${LTRD_VERSION_REV}.${LTRD_VERSION_PATCH})
 
 set(LTRD_DESCR_EN "Service for control ${LTR_CRATE_NAME} Crates and modules")
@@ -32,6 +32,9 @@
 
 option(SETUP_UPSTART "Setup upstart configuration file" OFF)
 
+if(NOT ${CMAKE_VERSION}  VERSION_LESS "3.0.0")
+    string(TIMESTAMP CURRENT_YEAR "%Y")
+endif()
 
 #добавляем путь к модулям cmake в path для cmake
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/")
@@ -116,9 +119,12 @@
     src/ltrsrv_crates.c
     src/ltrsrv_client.c
     src/ltrsrv_client_cmd.c
+    src/ltrsrv_cyclebuf.c
+    src/ltrsrv_params.c
     src/ltrsrv_eth.c
     src/modules/ltr34/ltrsrv_mspec_ltr34.c
     src/modules/ltr35/ltrsrv_mspec_ltr35.c
+    src/modules/ltr01/ltrsrv_mspec_ltr01.c
    )
 
 set(HEADERS
@@ -132,11 +138,16 @@
     src/ltrsrv_crates.h
     src/ltrsrv_client.h
     src/ltrsrv_client_p.h
+    src/ltrsrv_cyclebuf.h
+    src/ltrsrv_params.h
     src/ltrsrv_eth.h
     src/modules/ltr34/ltrsrv_mspec_ltr34.h
     src/modules/ltr35/ltrsrv_mspec_ltr35.h
+    src/modules/ltr01/ltrsrv_mspec_ltr01.h
+    lib/lbitfield/lbitfield.h
   )
 
+include_directories(lib/lbitfield)
 
 if(WIN32)
     configure_file(${PROJECT_SRC_NAME}.rc.in ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_SRC_NAME}.rc)
@@ -169,7 +180,7 @@
             OUTPUT
                 "${PROJECT_BINARY_DIR}/ltrsrv_event_msg.h"
                 "${PROJECT_BINARY_DIR}/ltrsrv_event_msg.rc"
-            COMMAND ${MC} -c
+            COMMAND ${MC_EXEC} -c
                 -U "${PROJECT_BINARY_DIR}/ltrsrv_event_msg.mc"
                 -r "${PROJECT_BINARY_DIR}"
                 -h "${PROJECT_BINARY_DIR}"
@@ -221,9 +232,15 @@
 find_package(LibXml2)
 if(LIBXML2_FOUND)
     set(HAVE_LIBXML2 ON)
-    include_directories(${LIBXML2_INCLUDE_DIR})
+    # по правилам d в проекте должна использоваться переменная  xxx_INCLUDE_DIRS,
+    # но в старых версиях cmake определялась только LIBXML2_INCLUDE_DIR
+    if (LIBXML2_INCLUDE_DIRS)
+        include_directories(${LIBXML2_INCLUDE_DIRS})
+    else()
+        include_directories(${LIBXML2_INCLUDE_DIR})
+    endif()
     set(LIBS ${LIBS} ${LIBXML2_LIBRARIES})
-    message(STATUS "libxml found: " ${LIBXML2_INCLUDE_DIR}, ${LIBXML2_LIBRARIES}, ${LIBXML2_DEFINITIONS})
+    message(STATUS "libxml2 found: ${LIBXML2_INCLUDE_DIRS}, ${LIBXML2_INCLUDE_DIR}, ${LIBXML2_LIBRARIES}, ${LIBXML2_DEFINITIONS}")
 endif(LIBXML2_FOUND)
 
 
@@ -345,18 +362,3 @@
     target_link_libraries(${PROJECT} m)
 
     if(LTRD_SYSTEMD_ENABLED)
-        #поиск библиотеки для взаимодействия с systemd (в старых версиях называлась systemd-daemon)
-        find_library(SYSTEMD_LIBRARY NAMES systemd systemd-daemon)
-        if(NOT SYSTEMD_LIBRARY)
-            message(FATAL_ERROR "systemd library not found")
-        endif(NOT SYSTEMD_LIBRARY)
-
-        message(STATUS "systemd library found: ${SYSTEMD_LIBRARY}")
-        target_link_libraries(${PROJECT} ${SYSTEMD_LIBRARY})
-    endif(LTRD_SYSTEMD_ENABLED)
-endif(UNIX)
-
-if(WIN32)
-    target_link_libraries(${PROJECT} Ws2_32 Iphlpapi)
-elseif(${CMAKE_SYSTEM_NAME} STREQUAL "QNX")
-    #в QNX для работы с API-сокетов нужно подключать отдельно библиотеку socket
