=== debian/changelog ===
ltrd (2.1.8.14) stable; urgency=low

  * Initial Release.

 -- Borisov Alexey <borisov@lcard.ru>  Mon, 26 Mar 2012 01:48:58 +0400
